"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ItiReactContext = exports.defaultItiReactContextData = void 0;
const react_1 = __importDefault(require("react"));
/**
 * Defaults for **parts** of [[`ItiReactContextData`]]. Does not include defaults
 * for properties where there is no reasonable default value.
 */
exports.defaultItiReactContextData = {
    themeColors: {
        primary: '#007bff',
        secondary: '#6c757d',
        success: '#28a745',
        info: '#17a2b8',
        warning: '#ffc107',
        danger: '#dc3545',
        light: '#f8f9fa',
        dark: '#343a40',
        inputPlaceholder: '#6c757d', // $gray-600,
    },
    fieldLengths: {
        address: {
            line1: 64,
            line2: 64,
            city: 64,
        },
        personName: {
            prefix: 64,
            first: 64,
            middle: 64,
            last: 64,
        },
    },
};
const throwFunction = () => {
    throw new Error('ItiReactContextData is not set.');
};
/**
 * A context that provides configuration values used by code within `iti-react-core`.
 * You must wrap your application in with `<ItiReactContext.Provider>` and
 * `<ItiReactCoreContext.Provider>`.
 */
// The default value set here should never be used
exports.ItiReactContext = react_1.default.createContext({
    ...exports.defaultItiReactContextData,
    renderLoadingIndicator: throwFunction,
    addressInput: { allowCanadian: false },
    configurablePager: { pageSizes: [10, 25, 50] },
});
