import React from 'react';
/** @internal */
export declare const pageActions: {
    setPage: import("@reduxjs/toolkit").ActionCreatorWithPayload<number, string>;
    setPageSize: import("@reduxjs/toolkit").ActionCreatorWithPayload<number, string>;
    showAllItems: import("@reduxjs/toolkit").ActionCreatorWithoutPayload<"showAllItems">;
};
/** @internal */
export declare const pageReducer: import("@reduxjs/toolkit/dist/createReducer").ReducerWithInitialState<{
    page: number;
    pageSize: number;
}>;
export interface ConfigurablePagerProps {
    page: number;
    pageSize: number;
    onChange(page: number, pageSize: number): void;
    totalPages: number;
    enabled?: boolean;
    pageSizes?: number[];
    showAllOption?: boolean;
}
/**
 * A pagination control that lets the user select how many items to show on a
 * page.
 *
 * The default page sizes are configured in [[`ItiReactContext`]] and can be
 * overridden with the `pageSizes` prop.
 *
 * You can show an "All" option by setting `showAllOption` to true. "All"
 * actually means a `pageSize` of 10000.
 */
export declare function ConfigurablePager({ page, pageSize, onChange, totalPages, enabled, showAllOption, ...props }: ConfigurablePagerProps): React.ReactElement;
