"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinkButton = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
/**
 * A quick way to create an element that looks like a link but behaves
 * like a button.
 */
function LinkButton({ children, onClick, ...passThroughProps }) {
    /* eslint-disable jsx-a11y/anchor-is-valid */
    return ((0, jsx_runtime_1.jsx)("a", { ...passThroughProps, href: "#", onClick: (e) => {
            e.preventDefault();
            if (onClick)
                onClick(e);
        }, role: "button", children: children }, void 0));
}
exports.LinkButton = LinkButton;
