import React, { PropsWithChildren } from 'react';
export interface TabOptions {
    className?: string;
}
/** `[tabId, tabName, tabOptions]` */
export declare type Tab = [string, string] | [string, string, TabOptions];
export declare type TabLayoutProps = PropsWithChildren<{
    tabs: Tab[];
    tab: string;
    onTabClick(tabId: string): void;
    className?: string;
    tabContentClassName?: string;
    tabContentRef?: React.Ref<HTMLDivElement>;
    tabContentStyle?: React.CSSProperties;
}>;
/**
 * A presentational component for building user interfaces with tabs.
 *
 * Usually you want to use [[`TabManager`]] which builds on top of `TabLayout`.
 */
export declare function TabLayout({ tabs, tab, onTabClick, className, tabContentClassName, tabContentRef, tabContentStyle, children, }: TabLayoutProps): React.ReactElement;
