"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TabLayout = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const LinkButton_1 = require("../LinkButton");
function TabLink(props) {
    const { tab, current, onClick } = props;
    const anchorClasses = ['nav-link'];
    if (current === tab[0])
        anchorClasses.push('active');
    if (tab.length === 3) {
        const tabOptions = tab[2];
        if (tabOptions.className)
            anchorClasses.push(tabOptions.className);
    }
    return ((0, jsx_runtime_1.jsx)("li", { className: "nav-item", children: (0, jsx_runtime_1.jsx)(LinkButton_1.LinkButton, { className: anchorClasses.join(' '), onClick: onClick, children: tab[1] }, void 0) }, void 0));
}
/**
 * A presentational component for building user interfaces with tabs.
 *
 * Usually you want to use [[`TabManager`]] which builds on top of `TabLayout`.
 */
function TabLayout({ tabs, tab, onTabClick, className, tabContentClassName, tabContentRef, tabContentStyle, children, }) {
    const navClasses = ['nav', 'nav-tabs'];
    const classes = ['tab-layout'];
    if (className)
        classes.push(className);
    const tabContentClasses = ['tab-content'];
    if (tabContentClassName)
        tabContentClasses.push(tabContentClassName);
    return ((0, jsx_runtime_1.jsxs)("div", { className: classes.join(' '), children: [(0, jsx_runtime_1.jsx)("ul", { className: navClasses.join(' '), children: tabs.map((t) => ((0, jsx_runtime_1.jsx)(TabLink, { tab: t, current: tab, onClick: () => onTabClick(t[0]) }, t[0]))) }, void 0), (0, jsx_runtime_1.jsx)("div", { className: tabContentClasses.join(' '), ref: tabContentRef, style: tabContentStyle, children: children }, void 0)] }, void 0));
}
exports.TabLayout = TabLayout;
