"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsyncSelectValidators = exports.ValidatedAsyncSelect = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importStar(require("react"));
const async_1 = __importDefault(require("react-select/async"));
const iti_react_core_1 = require("@interface-technologies/iti-react-core");
const debounce_promise_1 = __importDefault(require("debounce-promise"));
const ItiReactContext_1 = require("../../ItiReactContext");
const validation_1 = require("../../validation");
const CommonSelectProps_1 = require("./CommonSelectProps");
const SelectOption_1 = require("./SelectOption");
/**
 * A validated dropdown component based on `react-select` that loads its
 * options via an API call.
 *
 * This component is expensive to render so use `React.memo` when necessary.
 */
exports.ValidatedAsyncSelect = react_1.default.memo(({ id, name, validators, showValidation, loadOptions, placeholder, noOptionsMessage, className, inputClassName, formControlSize, width, components, isLoading, enabled = CommonSelectProps_1.defaultSelectProps.enabled, isClearable = CommonSelectProps_1.defaultSelectProps.isClearable, getStyles = CommonSelectProps_1.defaultSelectProps.getStyles, isOptionEnabled, menuIsOpen, onMenuOpen, onMenuClose, menuPlacement = CommonSelectProps_1.defaultSelectProps.menuPlacement, ...props }) => {
    const { value, onChange: _onChange } = (0, iti_react_core_1.useControlledValue)({
        value: props.value,
        onChange: props.onChange,
        defaultValue: props.defaultValue,
        fallbackValue: null,
    });
    function onChange(option0, actionMeta) {
        // option will be an array if the user presses backspace
        // This is so that if isClearable = false, null will never be passed to the
        // onChange prop
        if (!isClearable && actionMeta.action === 'pop-value')
            return;
        const option = option0;
        // Be careful with the conditional - option.value could be 0
        let newValue = null;
        if (option && option.value !== null) {
            newValue = option;
        }
        _onChange(newValue);
    }
    const validatorOutput = (0, iti_react_core_1.useValidation)({
        value,
        name,
        onValidChange: props.onValidChange,
        validators,
        validationKey: props.validationKey,
        asyncValidator: props.asyncValidator,
        onAsyncError: props.onAsyncError,
        formLevelValidatorOutput: props.formLevelValidatorOutput,
    });
    const { themeColors } = (0, react_1.useContext)(ItiReactContext_1.ItiReactContext);
    const stylesOptions = {
        valid: !validatorOutput,
        showValidation,
        themeColors,
        width,
        formControlSize,
        isMulti: false,
    };
    let isOptionDisabled;
    if (isOptionEnabled)
        isOptionDisabled = (o) => !isOptionEnabled(o);
    const loadOptionsRef = (0, react_1.useRef)(loadOptions);
    (0, react_1.useEffect)(() => {
        loadOptionsRef.current = loadOptions;
    });
    const loadOptionsDebouncedRef = (0, react_1.useRef)((0, debounce_promise_1.default)((inputValue) => loadOptionsRef.current(inputValue), 500));
    return ((0, jsx_runtime_1.jsx)(validation_1.ValidationFeedback, { validatorOutput: validatorOutput, showValidation: showValidation, className: className, children: (0, jsx_runtime_1.jsx)(async_1.default, { name: name, className: inputClassName, inputId: id, loadOptions: loadOptionsDebouncedRef.current, value: value, noOptionsMessage: noOptionsMessage, placeholder: placeholder, onChange: onChange, isClearable: isClearable, isDisabled: !enabled, isLoading: isLoading, isOptionDisabled: isOptionDisabled, styles: getStyles(stylesOptions), "aria-label": props['aria-label'], "aria-labelledby": props['aria-labelledby'], components: components, menuIsOpen: menuIsOpen, onMenuOpen: onMenuOpen, onMenuClose: onMenuClose, menuPlacement: menuPlacement, filterOption: SelectOption_1.filterOption }, void 0) }, void 0));
});
function required() {
    return (value) => {
        if (value === null)
            return iti_react_core_1.Validators.required()('');
        return undefined;
    };
}
exports.AsyncSelectValidators = {
    required,
};
